'use strict';

document.addEventListener('DOMContentLoaded', function () {
    $('#message_button').on('click', function () {
        newMessage();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#contact_button').on('click', function () {
        newContact();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#group_button').on('click', function () {
        newGroup();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#show_message_button').on('click', function () {
        showMessages();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#show_contacts_button').on('click', function () {
        showContacts();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#show_groups_button').on('click', function () {
        showGroups();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#message_delete_button').on('click', function () {
        deleteMessage();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#contact_delete_button').on('click', function () {
        deleteContact();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#group_delete_button').on('click', function () {
        deleteGroup();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#group_add_member_button').on('click', function () {
        addGroupMember();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#group_delete_member_button').on('click', function () {
        deleteGroupMember();
    });
});

var storageManager = new StorageManager();

function putMessage(messages, place) {
    document.getElementById(place).innerHTML = '';
    for (var prop in messages) {
        document.getElementById(place).innerHTML += 'mid: ' + prop;
        document.getElementById(place).innerHTML += ', cyphertext: ' + messages[prop].ciphertext;
        document.getElementById(place).innerHTML += ', plaintext: ' + messages[prop].plaintext;
        document.getElementById(place).innerHTML += ', contact: ' + messages[prop].contact;
        document.getElementById(place).innerHTML += ', group: ' + messages[prop].group;
        document.getElementById(place).innerHTML += ', timestamp: ' + messages[prop].timestamp;
    }
}

function putContact(contacts, place) {
    document.getElementById(place).innerHTML = '';
    for (var prop in contacts) {
        document.getElementById(place).innerHTML += 'local name: ' + prop;
        document.getElementById(place).innerHTML += ', server name: ' + contacts[prop].name;
        document.getElementById(place).innerHTML += ', registered ' + 'deviceIDs: ' + contacts[prop].devices;
    }
}

function putGroup(groups, place) {
    document.getElementById(place).innerHTML = '';
    for (var prop in groups) {
        document.getElementById(place).innerHTML += 'group name: ' + prop;
        document.getElementById(place).innerHTML += ', gid: ' + groups[prop].gid;
        document.getElementById(place).innerHTML += ', members: ' + groups[prop].members;
    }
}

function newMessage() {
    var mid = document.getElementById('mid').value;
    var cypher = document.getElementById('mcypher').value;
    var plain = document.getElementById('mplain').value;
    var contact = document.getElementById('mcontact').value;
    var group = document.getElementById('mgroup').value;
    var timestamp = document.getElementById('mtimestamp').value;
    var args = ['message'];
    storageManager.addMessage(mid, cypher, plain, contact, group, timestamp, putMessage, args);
}

function newContact() {
    var localName = document.getElementById('clocal').value;
    var serverName = document.getElementById('cserver').value;
    var device = document.getElementById('cdevice').value;
    var args = ['contact'];
    storageManager.addContact(localName, serverName, device, putContact, args);
}

function newGroup() {
    var gname = document.getElementById('gname').value;
    var gid = document.getElementById('gid').value;
    var gmembers = [document.getElementById('gmembers').value];
    var args = ['group'];
    storageManager.addGroup(gname, gid, gmembers, putGroup, args);
}

function showMessages() {
    var args = ['messages_here'];
    storageManager.getMessages(putMessage, args);
}

function showContacts() {
    var args = ['contacts_here'];
    storageManager.getContacts(putContact, args);
}

function showGroups() {
    var args = ['groups_here'];
    storageManager.getGroups(putGroup, args);
}

function deleteMessage() {
    var mid = document.getElementById('mid_delete').value;
    var args = ['messages_here'];
    storageManager.deleteMessage(mid, putMessage, args);
}

function deleteContact() {
    var name = document.getElementById('user_delete').value;
    var args = ['contacts_here'];
    storageManager.deleteContact(name, putContact, args);
}

function deleteGroup() {
    var group = document.getElementById('group_delete').value;
    var args = ['groups_here'];
    storageManager.deleteGroup(group, putGroup, args);
}

function addGroupMember() {
    var groupName = document.getElementById('add_member_group');
    var member = document.getElementById('add_member_name');
    var args = ['groups_here'];
    storageManager.addGroupMember(groupName, member, putGroup, args);
}

function deleteGroupMember() {
    var groupName = document.getElementById('delete_member_group');
    var member = document.getElementById('delete_member_name');
    var args = ['groups_here'];
    storageManager.deleteGroupMember(groupName, member, putGroup, args);
}