'use strict';

document.addEventListener('DOMContentLoaded', function () {
    $('#addgroup').on('click', function () {
        disp();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#addcontact').on('click', function () {
        contact();
    });
});

var number = 0;
updateContacts();
updateGroups();

function disp() {
    var x = document.createElement('INPUT');
    x.setAttribute('id', 'newgroupname');
    x.id = 'newgroupname';
    x.setAttribute('type', 'text');
    document.getElementById('groupadd').innerHTML = '';
    document.getElementById('groupadd').appendChild(x);
    var btn = document.createElement('BUTTON');
    btn.className = 'blue btn';
    btn.onclick = addGroup;
    var txt = document.createTextNode('Add');
    btn.appendChild(txt);
    document.getElementById('groupadd').appendChild(btn);
}

function addGroup() {
    var x = document.getElementById('addgroup');
    var groupName = document.getElementById('newgroupname').value;
    document.getElementById('groupadd').innerHTML = '';
    var ul = document.createElement('ul');
    var li = document.createElement('li');
    li.innerHTML = groupName + ' [-]';
    li.id = number;
    ul.id = number;
    number++;
    var btn = document.createElement('BUTTON');
    var txt = document.createTextNode('del');
    btn.className = 'blue btn';
    btn.appendChild(txt);
    btn.onclick = function () {
        ul.innerHTML = '';
    };
    var innerUl = document.createElement('ul');
    innerUl.id = 'searchResults';
    var plus = document.createElement('li');
    plus.innerHTML = '[+]';
    plus.onclick = '';
    innerUl.appendChild(plus);
    li.appendChild(innerUl);
    ul.appendChild(li);
    ul.appendChild(btn);
    document.getElementById('groups').appendChild(ul);

    chrome.storage.local.get({ groups: [] }, function (result) {
        var groups = result.groups;
        var group = { name: groupName, members: [] };
        groups.push(group);
        chrome.storage.local.set({ groups: groups }, function () {
            updateGroups();
        });
    });
}

function updateGroups() {
    var groups = undefined;
    chrome.storage.local.get({ groups: [] }, function (result) {
        var list = document.getElementById('groups');
        list.innerHTML = '';

        var _loop = function (prop) {
            var _loop2 = function (i) {
                var ul = document.createElement('ul');
                var li = document.createElement('li');
                var name = 'fail';
                try {
                    name = result[prop][i]['name'];
                } catch (err) {
                    name = 'fail';
                }
                li.innerHTML = name;
                var innerUL = document.createElement('ul');
                li.appendChild(innerUL);
                for (var j = 0; j < result[prop][i]['members'].length; j++) {
                    var li2 = document.createElement('li');
                    li2.innerHTML = result[prop][i]['members'][j];
                    innerUL.appendChild(li2);
                }
                ul.appendChild(li);
                list.appendChild(ul);
                var btn = document.createElement('BUTTON');
                btn.className = 'blue btn';
                var txt = document.createTextNode('delete group');
                btn.appendChild(txt);
                btn.onclick = function () {
                    result[prop].splice(i, 1);
                    ul.innerHTML = '';
                    groups = result.groups;
                    chrome.storage.local.set({ groups: groups }, function () {
                        return true;
                    });
                };
                ul.appendChild(btn);
                var drop = document.createElement('SELECT');
                chrome.storage.local.get({ contacts: [] }, function (res) {
                    for (var pro in res) {
                        for (var j = 0; j < res[pro].length; j++) {
                            var opt = document.createElement('option');
                            opt.text = res[pro][j];
                            opt.value = j;
                            drop.add(opt);
                        }
                    }
                });
                ul.appendChild(drop);
                var btn2 = document.createElement('BUTTON');
                btn2.className = 'blue btn';
                var txt2 = document.createTextNode('add member');
                btn2.appendChild(txt2);
                btn2.onclick = function () {
                    result[prop][i]['members'].push(drop.options[drop.value].innerHTML);
                    groups = result.groups;
                    var li2 = document.createElement('li');
                    li2.innerHTML = drop.options[drop.value].innerHTML;
                    innerUL.appendChild(li2);
                    chrome.storage.local.set({ groups: groups }, function () {
                        updateGroups();
                    });
                };
                ul.appendChild(btn2);
                var drop2 = document.createElement('SELECT');
                for (var j = 0; j < result[prop][i]['members'].length; j++) {
                    var opt = document.createElement('option');
                    opt.text = result[prop][i]['members'][j];
                    opt.value = j;
                    drop2.add(opt);
                }
                ul.appendChild(drop2);
                var btn3 = document.createElement('BUTTON');
                btn3.className = 'blue btn';
                var txt3 = document.createTextNode('delete member');
                btn3.appendChild(txt3);
                btn3.onclick = function () {
                    try {
                        result[prop][i]['members'].splice(drop2.value, 1);
                        groups = result.groups;
                        chrome.storage.local.set({ groups: groups }, function () {
                            updateGroups();
                        });
                    } catch (err) {
                        document.getElementById('debug2').innerHTML = result[prop][i]['members'] + ' ' + drop2.value;
                    }
                };
                ul.appendChild(btn3);
            };

            for (var i = 0; i < result[prop].length; i++) {
                _loop2(i);
            }
        };

        for (var prop in result) {
            _loop(prop);
        }
    });
}

function deleteGroup(id) {
    document.getElementById(id).innerHTML = '';
}

function contact() {
    var x = document.createElement('INPUT');
    x.setAttribute('id', 'newcontactname');
    x.id = 'newcontactname';
    x.setAttribute('type', 'text');
    document.getElementById('newcontact').innerHTML = '';
    document.getElementById('newcontact').appendChild(x);
    var btn = document.createElement('BUTTON');
    btn.className = 'blue btn';
    btn.onclick = addContact;
    var txt = document.createTextNode('Add');
    btn.appendChild(txt);
    document.getElementById('newcontact').appendChild(btn);
}

function addContact() {
    var x = document.getElementById('addgroup');
    var contact = document.getElementById('newcontactname').value;
    document.getElementById('newcontact').innerHTML = '';
    var contacts = [];

    chrome.storage.local.get({ contacts: [] }, function (result) {
        var contacts = result.contacts;
        contacts.push(contact);
        chrome.storage.local.set({ contacts: contacts }, function () {
            updateContacts();
            updateGroups();
        });
    });
}

function updateContacts() {
    chrome.storage.local.get({ contacts: [] }, function (result) {
        var list = document.getElementById('contactlist');
        list.innerHTML = '';

        var _loop3 = function (i) {
            var li = document.createElement('li');
            li.innerHTML = result.contacts[i];
            li.onclick = function () {
                list.removeChild(li);
                result.contacts.splice(i, 1);
                var contacts = result.contacts;
                chrome.storage.local.set({ contacts: contacts }, function () {
                    updateGroups();
                    updateContacts();
                });
            };
            list.appendChild(li);
        };

        for (var i = 0; i < result.contacts.length; i++) {
            _loop3(i);
        }
    });
}

function addToStorageList(id, item, callback) {
    chrome.storage.local.get(id, function (result) {
        var ans = result[id] || [];
        ans.push(item);
        chrome.storage.local.set({ id: ans }, callback());
    });
}

function update() {
    updateGroups();
    updateContacts();
}